//
//  MyViewAxes.swift
//  Example31Scale
//
//  Created by 川上 博 on 2015/01/04.
//  Copyright (c) 2015年 Hiroshi Kawakami. All rights reserved.
//

import Cocoa

extension MyView {
    
    func drawMoji(num: Double, xloc xpos: Double, yloc ypos: Double, hvmode hv: Int){
        var strlength: Int = 0
        var str: String = NSString() as String
        let attribs = [
            NSFontAttributeName : NSFont(name: "Helvetica", size: 14)!,
            NSForegroundColorAttributeName : NSColor.blueColor()
        ]
        str = NSString(format: "%.1f", num) as String
        strlength = str.utf16.count
        if(hv == 0){
            str.drawAtPoint(NSMakePoint(CGFloat(xpos - Double(strlength)*4.0+2.0), CGFloat(ypos-24.0)), withAttributes: attribs )
        }else{
            str.drawAtPoint(NSMakePoint(CGFloat(xpos - Double(strlength)*4.0-14.0), CGFloat(ypos-8.0)), withAttributes: attribs)
        }
    }
    
    func drawAxes(){
        let ticx = 5
        let ticy = 5
        var ix : Double, iy : Double, k : Int, lt0 : Int, lt1 : Int, lt2 : Int
        var temp : Double, b: [Double] = [0.0, 0.0]
        let pat : [CGFloat] = [3.0, 1.5]
//        var r = NSRect()
        let bp = NSBezierPath()
        let bp2 = NSBezierPath()  // for dotted line
        
        b[0] = sfactor[0]*(xm[1]-xm[0])
        b[1] = sfactor[1]*(ym[1]-ym[0])
        
 //       NSColor.blueColor().set()
        bp.lineWidth = 1.0
        bp2.lineWidth = 0.3
        
        lt0 = Int(hm[0])
        lt1 = lt0 + ticy
        lt2 = lt0 + ticy * 2
        temp = xm[0]
        
        k = 0
        while( (temp - (xm[1]+0.01*la[0])) <= 0.0){
            ix = wm[0]+sfactor[0]*(temp-xm[0])
            if (k%lav[0] == 0){
                if(temp<xm[1]-0.1*la[0] && temp>xm[0]+0.1*la[0])    {
                    bp.moveToPoint(NSMakePoint(CGFloat(ix),CGFloat(lt0)))
                    bp.lineToPoint(NSMakePoint(CGFloat(ix),CGFloat(lt2)))
                    if( k != 0){
                        bp2.setLineDash(pat, count:2, phase:0)
                        bp2.moveToPoint(NSMakePoint(CGFloat(ix),CGFloat(lt2)))
                        bp2.lineToPoint(NSMakePoint(CGFloat(ix), CGFloat(hm[0]+b[1])))
                    }
                }
                self.drawMoji(temp, xloc: Double(ix), yloc: Double(lt0), hvmode: 0)
                k = 0
            }else{
                if(temp<xm[1]-0.1*la[0] && temp>xm[0]+0.1*la[0]){
                    bp.moveToPoint(NSMakePoint(CGFloat(ix), CGFloat(lt0)))
                    bp.lineToPoint(NSMakePoint(CGFloat(ix), CGFloat(lt1)))
                }
            }
            temp += la[0]
            k++
        }
        //	[bp stroke];
        
        //tics and labels for y-axis
        lt0 = Int(wm[0])
        lt1 = lt0 + ticx
        lt2 = lt0 + ticx * 2
        temp = ym[0]
        k = 0
        while ((temp - (ym[1]+0.01*la[1]))<=0.0){
            iy = hm[0] + sfactor[1]*(temp-ym[0])
            if(k%lav[1] == 0){
                if(temp<ym[1]-0.1*la[1] && temp>ym[0]+0.1*la[1]){
                    bp.moveToPoint(NSMakePoint(CGFloat(lt0),CGFloat(iy)))
                    bp.lineToPoint(NSMakePoint(CGFloat(lt2),CGFloat(iy)))
                    if(k != 0){
                        bp2.setLineDash(pat, count:2, phase:0)
                        bp2.moveToPoint(NSMakePoint(CGFloat(lt2),CGFloat(iy)))
                        bp2.lineToPoint(NSMakePoint(CGFloat(wm[0]+b[0]),CGFloat(iy)))
                    }
                }
                self.drawMoji(temp, xloc:Double(lt0), yloc:Double(iy), hvmode:1)
                k=0;
            } else{
                if(temp<ym[1]-0.1*la[1] && temp>ym[0]+0.1*la[1]){
                    bp.moveToPoint(NSMakePoint(CGFloat(lt0), CGFloat(iy)))
                    bp.lineToPoint(NSMakePoint(CGFloat(lt1), CGFloat(iy)))
                }
            }
            temp += la[1];
            k++;
        }
        bp.stroke()
        bp.appendBezierPathWithRect(NSMakeRect(CGFloat(wm[0]), CGFloat(hm[0]), CGFloat(b[0]),CGFloat(b[1])))
        bp.stroke()
        bp2.stroke()
    }
}