//
//  MyView.swift
//  Example32vdP
//
//  Created by 川上 博 on 2014/12/26.
//  Copyright (c) 2014年 Hiroshi Kawakami. All rights reserved.
//

import Cocoa

class MyView : NSView {

// -------------- global variables
    var x:[Double]=[0.0, 0.0]  // system
    var t: Double = 0.0
    
    var bp = NSBezierPath()    // drawing
    var xm:[Double]=[0.0, 0.0]
    var ym:[Double]=[0.0, 0.0]
    var sfactor:[Double]=[0.0, 0.0]
// --------------

   
    override func awakeFromNib(){
        xm[0] = -3.0; xm[1] = 3.0; ym[0] = -3.0; ym[1] = 3.0
        x[0] = 0.1; x[1] = 0.0
    }
    
    override func drawRect(dirtyRect: NSRect) {
        NSColor.whiteColor().set()
        NSRectFill(self.bounds)
        NSColor.blueColor().set()
        
        sfactor[0] = (Double)(dirtyRect.size.width) / (xm[1] - xm[0])
        sfactor[1] = (Double)(dirtyRect.size.height) / (ym[1] - ym[0])
        
        self.drawTrajectory()
    }
}

