//
//  MyView.swift
//  Example33ScaledvdP
//
//  Created by 川上 博 on 2015/01/04.
//  Copyright (c) 2015年 Hiroshi Kawakami. All rights reserved.
//

import Cocoa

class MyView: NSView {
// ---------------- global variables -----------------
    var x : [Double] = [0.0, 0.0]
    var t : Double = 0.0
    
    var sfactor : [Double] = [1.0, 1.0]
    var xm : [Double] = [-3.0, 3.0]
    var ym : [Double] = [-3.0, 3.0]
    var wm : [Double] = [50.0, 30.0]
    var hm : [Double] = [50.0, 30.0]
    var la : [Double] = [0.2, 0.2]
    var lav : [Int] = [5, 5]
// ---------------- global variables -----------------
    
    override func awakeFromNib(){
        xm[0] = -3.0; xm[1] = 3.0; ym[0] = -3.0; ym[1] = 3.0;
        wm[0] = 50.0; wm[1] = 30.0; hm[0] = 50.0; hm[1] = 30.0;
        la[0] = 0.2; la[1] = 0.2; lav[0] = 5; lav[1] = 5;
        x[0] = 0.1; x[1] = 0.0
    }
    
    override func drawRect(dirtyRect: NSRect) {
        NSColor.whiteColor().setFill()
        NSRectFill(self.bounds)
        
        sfactor[0] = (Double(self.bounds.size.width) - wm[0] - wm[1]) / (xm[1] - xm[0])
        sfactor[1] = (Double(self.bounds.size.height) - hm[0] - hm[1]) / (ym[1] - ym[0])
        
        self.drawAxes()
        //insert your program here.
//        self.shape()
        self.drawTrajectory()

    }
    
    
}
